program day1
    implicit none
    integer, parameter :: max_masses = 10000
    integer :: n_arguments
    integer :: f_sum = 0
    integer :: f_full_sum = 0
    integer :: this_fuel, this_full_fuel, this_mass
    integer :: i, istat
    character(200) :: fname
    n_arguments = command_argument_count()
    if (n_arguments .eq. 1) then
        call get_command_argument(1, fname)
        print *, "File: ", fname
    else
        print *, "Wrong number of arguments: ", n_arguments
        stop
    end if
    open(10, file=fname)
    do i=1,max_masses
        read (10, *, iostat = istat) this_mass
        if (is_iostat_end(istat)) then
            exit
        end if
        this_fuel = fuelcalc(this_mass)
        this_full_fuel = fullfuelcalc(this_mass)
        f_sum = f_sum + this_fuel
        f_full_sum = f_full_sum + this_full_fuel
        print *, i, this_mass, this_fuel, f_sum, this_full_fuel, f_full_sum
    end do
    close(10)
    print *
    print *, f_sum, f_full_sum

    contains
        function fuelcalc(mass)
            implicit none
            integer, intent(in) :: mass
            integer :: fuelcalc
            fuelcalc = mass / 3 - 2
        end function fuelcalc

        function fullfuelcalc(mass)
            implicit none
            integer, parameter :: max_iterations = 10000
            integer, intent(in) :: mass
            integer :: fullfuelcalc
            integer :: ftemp
            integer :: i
            ftemp = mass
            fullfuelcalc = 0
            do i=1,max_iterations
                ftemp = fuelcalc(ftemp)
                if (ftemp .le. 0) then
                    exit
                else
                    fullfuelcalc = fullfuelcalc + ftemp
                end if
            end do
            if (ftemp .gt. 0) then
                print *, "Too many iterations for mass", mass
                stop
            end if
        end function fullfuelcalc
end program day1

