program day4
    implicit none
    integer, parameter :: max_chars = 200
    integer, parameter :: max_cards = 1000
    character(200) :: fname
    integer :: n_arguments
    integer :: n_winning, n_have
    character(max_chars) :: str
    integer :: card
    integer :: pos_col, pos_pipe, str_len
    integer :: sum_points = 0
    integer :: points, matches
    integer :: istat
    integer, allocatable :: winning_nums(:)
    integer, allocatable :: card_nums(:)
    integer :: extra_cards(1:max_cards)
    integer :: total_cards = 0
    integer :: card_iter
    integer :: this_cards

    n_arguments = command_argument_count()
    if (n_arguments .eq. 3) then
        call get_command_argument(1, fname)
        print *, "File: ", fname
        call get_command_argument(2, str)
        read (str, *) n_winning
        call get_command_argument(3, str)
        read (str, *) n_have
    else
        print *, "Wrong number of arguments: ", n_arguments
        stop
    end if
    allocate(winning_nums(1:n_winning))
    allocate(card_nums(1:n_have))
    open(10, file=fname)
    do card=1,max_cards
        extra_cards = 0
    end do
    do card=1,max_cards
        read(10, "(A)", iostat = istat) str
        str_len = len_trim(str)
        if (is_iostat_end(istat)) then
            exit
        else if (str_len .eq. 0) then
            exit
        end if
        pos_col = scan(str, ":")
        pos_pipe = scan(str, "|")
        read(str((pos_col + 1):(pos_pipe - 1)), *) winning_nums
        read(str((pos_pipe + 1):(str_len)), *) card_nums
        matches = cal_matches(winning_nums, card_nums)
        this_cards = extra_cards(card) + 1
        if (matches .gt. 0) then
            do card_iter = 1, matches
                extra_cards(card + card_iter) = extra_cards(card + card_iter) + this_cards
            end do
        end if
        points = cal_points(matches)
        sum_points = sum_points + points
        total_cards = total_cards + this_cards
    end do
    close(10)
    print *, "Total points: ", sum_points
    print *, "Total cards:  ", total_cards

    deallocate(winning_nums)
    deallocate(card_nums)

    contains
        function cal_matches(win_nums, held_nums)
            integer, intent(in) :: win_nums(:)
            integer, intent(in) :: held_nums(:)
            integer :: cal_matches
            integer :: i1, i2
            integer :: l_win, l_held
            cal_matches = 0
            l_win = size(win_nums)
            l_held = size(held_nums)
            do i1 = 1,l_win
                do i2 = 1,l_held
                    if (win_nums(i1) .eq. held_nums(i2)) then
                        cal_matches = cal_matches + 1
                    end if
                end do
            end do
        end function cal_matches

        function cal_points(matches)
            integer, intent(in) :: matches
            integer :: cal_points
            if (matches .eq. 0) then
                cal_points = 0
            else
                cal_points = 2**(matches - 1)
            end if
        end function cal_points

end program day4
